// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

#pragma once

#include <memory>

#include "arrow/util/visibility.h"

namespace arrow {
namespace util {
namespace tracing {

class ARROW_EXPORT SpanDetails {
 public:
  virtual ~SpanDetails() {}
};

class ARROW_EXPORT Span {
 public:
  Span() noexcept;
  /// True if this span has been started with START_SPAN
  bool valid() const;
  /// End the span early
  void reset();
  std::unique_ptr<SpanDetails> details;
};

}  // namespace tracing
}  // namespace util
}  // namespace arrow
